package  
{
	import adobe.utils.ProductManager;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.geom.Point;
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Tilemap;
	import net.flashpunk.masks.Grid;
	import net.flashpunk.World;
	import net.flashpunk.FP;
	
	public class LevelEditor 
	{
		public static var tileSets:Array = new Array();
		private static var _mapData:BitmapData;
		private static var _mapArray:Array;
		private static var _tileIndex:int;
		private static var _tileWidth:uint;
		private static var _tileHeight:uint;
		
		private static var _width:uint;
		private static var _height:uint;
		
		private static var _image:Bitmap;
		private static var _imageData:BitmapData;

		private static var _tilemap:Tilemap;
		private static var _grid:Grid;
		
		private static var r:uint = 0;
		private static var c:uint = 0;
		
		/*names to define by
		 *@param name name of this set
		 *@param imageSource source of the image for tiles to place
		 *@param tileChart Reference to image used.
		 *@param tileWidth width of the tiles used in this set.
		 *@param tileHeight Height of the ties used in this set.
		 * done commenting. */
		public static function DefineTileset(name:String, imageSource:*, tileChart:*, tileWidth:uint, tileHeight:uint):void
		{
			var molds:Array = new Array();
			
			if (tileChart is Array)
			{
				molds = tileChart;
			}
			else
			{
				var mold:BitmapData = (new tileChart() as Bitmap).bitmapData;
				
				for (r = 0; r < mold.height; r++)
				{
					for (c = 0; c < mold.width; c++)
					{
						molds.push(mold.getPixel(c, r));
					}
				}
			}
			if (tileSets.indexOf(name) == -1)
			{
				tileSets.push(name);
				tileSets.push(imageSource);
				tileSets.push(molds);
				tileSets.push(new Point(tileWidth, tileHeight));
			}
			else
			{
				var replace:uint = tileSets.indexOf(name);
				tileSets[replace] = name;
				tileSets[replace +1] = imageSource;
				tileSets[replace +2] = molds;
				tileSets[replace +3] = new Point(tileWidth, tileHeight);
			}
		}
		/* need theses tooooo creat tile mapppp
		 * @param tileSet name of tileset to use
		 * @param mapSource this si the souce of the image thingy, like  a bit map.
		 * @param tilewidth
		 * @param tileheight
		 * @param initialX
		 * @param initialY
		 * @return
		 * 
		 */
		public static function CreatTilemap(tileSet:String, mapSource:*, initialX:uint = 0, initialY:uint = 0):Tilemap
		{
			_tileIndex = tileSets.indexOf(tileSet);
			if (_tileIndex < 0)
			{
				throw new Error("Tileset:" + String(tileSet) + "cannot be found.");
				return _tilemap;
			}
			_image = new tileSets[_tileIndex + 1] as Bitmap;
			_imageData = _image.bitmapData;
			
			_tileWidth = tileSets[_tileIndex + 3].x;
			_tileHeight = tileSets[_tileIndex + 3].y;
			
			_mapData = (new mapSource() as Bitmap).bitmapData;
			_width = _mapData.width * _tileWidth;
			_height = _mapData.height * _tileHeight;
			_mapArray = new Array(_mapData.width);
			
			for (c = 0; c < _mapData.width; c++)
			{
				_mapArray[c] = new Array(_mapData.height);
				
				for (r = 0; r < _mapData.height; r++)
				{
					_mapArray[c][r] = _mapData.getPixel(c, r);
				}
			}
			
			_tilemap = new Tilemap(_imageData, _width, _height, _tileWidth, _tileHeight) as Tilemap;
			_tilemap.x = initialX;
			_tilemap.y = initialY;
			
			Setup();
			
			return _tilemap;
		}
		
		private static function Setup():void
		{
			var relationIndex:int = 0;
			
			for (c = 0; c < _mapData.width; c++)
			{
				for (r = 0; r < _mapData.height; r++)
				{
					relationIndex = tileSets[_tileIndex +2].indexOf(_mapData.getPixel(c, r));
					
					if (relationIndex >= 0)
					{
						_tilemap.setTile(c, r, relationIndex);
					}
				}
			}
		}
		/* need to creat the GRID woothhehehoooooo!
		 * @param tileSet name of the tileset duh by know you should know this... 
		 * @param mapSource source of the image file
		 * @param colliderChart array of colliders
		 * @param initialX
		 * @param initialY
		 * @return
		 * 
		 */
		
		public static function CreatGrid(tileSet:String, mapSource:*, colliderChart:*, initialX:Number = 0, initialY:Number = 0):Grid
		{
			_tileIndex = tileSets.indexOf(tileSet);
			if (_tileIndex < 0)
			{
				throw new Error("Tileset:" + String(tileSet) + "Cannot be found!!!!! GOON!");
				return _grid;
			}
			var collision:Array = new Array;
			var collidersData:BitmapData;
			var mapData:BitmapData = (new mapSource() as Bitmap).bitmapData;
			
			_tileWidth = tileSets[_tileIndex + 3].x;
			_tileHeight = tileSets[_tileIndex + 3].y;
			
			_grid = new Grid(_width, _height, _tileWidth, _tileHeight, initialX, initialY);
			
			if (colliderChart is Array)
				collision = colliderChart;
			else if (colliderChart is Class)
			{
				collidersData = (new colliderChart() as Bitmap).bitmapData;
				for (r = 0; r < collidersData.height; r++)
				{
					for (c = 0; c < collidersData.width; c++)
					{
						collision.push(collidersData.getPixel(c, r));
					}
				}
			}
			
			for (r = 0; r < mapData.height; r++)
			{
				for (c = 0; c < mapData.width; c++)
				{
					if (collision.indexOf(mapData.getPixel(c, r)) >= 0)
					{
						_grid.setTile(c, r);
					}
				}
			}
			
			return _grid;
		}
		/* now for the placement of enditititiees i use this... sometimes! :D
		 * @param tileSet name of the tileset
		 * @param entities    a list of entities to place
		 * @param entityChart Reference image or array of values to represent the entites at the same ting
		 * @param mapSource image file map
		 * @param world the world to add these enties to defaults to the FP.world if left null
		 */
		
		public static function PlaceEntites(tileSet:String, entities:Array, entityChart:*, mapSource:*, world:World = null):void
		{
			var placeData:BitmapData = (new mapSource() as Bitmap).bitmapData;
			var rep:Array = new Array();
			var repData:BitmapData;
			var index:int = 0;
			var newbie:Entity;
			
			_tileWidth = tileSets[_tileIndex +3].x;
			_tileHeight = tileSets[_tileIndex +3].y;
			world = (world == null) ? FP.world : world;
			
			if (entityChart is Array)
				rep = entityChart;
			else if (entityChart is Class)
			{
				repData = (new entityChart() as Bitmap).bitmapData;
				for (r = 0; r < repData.height; r++)
				{
					for (c = 0; c < repData.width; c++)
					{
						rep.push(repData.getPixel(c, r));
					}
				}
			}
			for (r = 0; r < placeData.height; r++)
			{
				for (c = 0; c < placeData.width; c++)
				{
					index = rep.indexOf(placeData.getPixel(c, r));
					if (index >= 0)
					{
						index = index % entities.length;
						newbie = world.add(new entities[index]);
						newbie.x = c * _tileWidth;
						newbie.y = r * _tileHeight;
					}
				}
			}
		}
	}
}