package coolthings 
{
	import enemies.Fly;
	import enemies.Kitten;
	import flash.geom.Rectangle;
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.FP;
	import net.flashpunk.*;
	import net.flashpunk.utils.*;
	import net.flashpunk.graphics.*;
	import player.Player;
	/**
	 * ...
	 * @author Commanderstitch
	 */
	public class Cookie extends Entity 
	{
		//generate a spritemap for explosions by ME haha!
		public const WIDTH:Number = 32;
		public const HEIGHT:Number = 32;
		
		public var boomSpritemap:Spritemap = new Spritemap(Assets.COOKIE, WIDTH, HEIGHT);
		
		public var curAnimation:String = "13";
		public static var cookielife:Number = 13;
		
		public function Cookie(x:Number,y:Number) 
		{
			super(x, y);
			setupSpritesheet();
			graphic = boomSpritemap;
			boomSpritemap.play("13");
			setHitbox(32,32);
			type = "cookie";
			layer = -1;
		}
		override public function update():void
		{
			super.update();
			boomSpritemap.play(curAnimation);
			cookieanimation();
			if (collide("bed", x, y))
			{
				destroy();
				new Sfx(Assets.HIDCOOKIE).play();
				Globals.cookiesdelivered--;
				Player.mastercookietrigger = true;
				Player.smallcookietrigger = true;
				cookielife = 13;
			}
			var r:Fly = collide("fly", x, y) as Fly;
			if (r)
			{
				new Sfx(Assets.MUNCH).play();
				r.destroy();
				cookielife--;
			}
			var c:Kitten = collide("fly", x, y) as Kitten;
			if (c)
			{
				new Sfx(Assets.MUNCH).play();
				c.destroy();
				cookielife--;
			}
			
			if (cookielife <= 0)
			{
				destroy();
				Player.mastercookietrigger = true;
				Player.smallcookietrigger = true;
				if (Globals.cookies == 2)
					Globals.cookies = 3;
				if (Globals.cookies == 1)
					Globals.cookies = 2;
				if (Globals.cookies == 0)
					Globals.cookies = 1;
				cookielife = 13;
			}
		}
		public function setupSpritesheet():void
		{
			boomSpritemap.add("13", [0], 0, false);
			boomSpritemap.add("12", [1], 0, false);
			boomSpritemap.add("11", [2], 0, false);
			boomSpritemap.add("10", [3], 0, false);
			boomSpritemap.add("9", [4], 0, false);
			boomSpritemap.add("8", [5], 0, false);
			boomSpritemap.add("7", [6], 0, false);
			boomSpritemap.add("6", [7], 0, false);
			boomSpritemap.add("5", [8], 0, false);
			boomSpritemap.add("4", [9], 0, false);
			boomSpritemap.add("3", [10], 0, false);
			boomSpritemap.add("2", [11], 0, false);
			boomSpritemap.add("1", [12], 0, false);
			boomSpritemap.add("0", [13], 0, false);
		}
		public function destroy():void
		{
			FP.world.remove(this);
		}
		public function cookieanimation():void
		{
			if (cookielife == 13)
				curAnimation = "13";
			else if (cookielife == 12)
				curAnimation = "12";
			else if (cookielife == 11)
				curAnimation = "11";
			else if (cookielife == 10)
				curAnimation = "10";
			else if (cookielife == 9)
				curAnimation = "9";
			else if (cookielife == 8)
				curAnimation = "8";
			else if (cookielife == 7)
				curAnimation = "7";
			else if (cookielife == 6)
				curAnimation = "6";
			else if (cookielife == 5)
				curAnimation = "5";
			else if (cookielife == 4)
				curAnimation = "4";
			else if (cookielife == 3)
				curAnimation = "3";
			else if (cookielife == 2)
				curAnimation = "2";
			else if (cookielife == 1)
				curAnimation = "1";
			else if (cookielife == 0)
				curAnimation = "0";
		}
		
	}

}