package enemies 
{
	import flash.geom.Point;
	import net.flashpunk.Entity;
	import net.flashpunk.*;
	import net.flashpunk.utils.*;
	import net.flashpunk.graphics.*;
	import player.Player;
	import worlds.rooms.Bedroom;
	import worlds.rooms.Livingroom;
	import player.Bubble;
	/**
	 * ...
	 * @author Commanderstitch
	 */
	public class EvilSister extends Entity 
	{		
		//define the dimensions of a single frame.
		public const SPRITE_WIDTH:Number = 46;
		public const SPRITE_HEIGHT:Number = 56;
		
		//create the spritemap
		
		public var playerSpritemap:Spritemap = new Spritemap(Assets.EVILSISTER, SPRITE_WIDTH, SPRITE_HEIGHT);
		
		//helper variables
		public var curAnimation:String = "stand_down";
		public static var speed:Number = .1;
		public var flyhealth:Number = 100;
		public var woodenspoontimer:Number = 110;
		public const TIMER:Number = 110;
		
		private const turnspeed:Number = 4;
		private const SPEEDFORCOOKIE:Number = 4;
		private const RAD:Number = Math.PI / 180;
		private var vx:Number;
		private var vy:Number;
		private var angle:Number;
		private var targetDir_x:Number;
		private var targetDir_y:Number;
		private var target:Entity;
		private var image:Image;
		
		public function EvilSister(x:int,y:int) 
		{
			super(x, y);
			setupSpritesheet();
			graphic = playerSpritemap;
			playerSpritemap.play(curAnimation);
			setHitbox(20, 26,-10,-10);
			type = "fly";
			layer - 3;
			new Sfx(Assets.ILOVECOOKIES).play();
		}
		public function begin():void
		{

		}
		override public function update():void
		{
			var horizontalMovement:Boolean = true;
			var verticalMovement:Boolean = true;
			if (woodenspoontimer <= 0)
			{
				for (var i:int = 0; i < 20; i++) //ouch!
					FP.world.add(new SisterMolecule(x, y));
				woodenspoontimer = TIMER;
			}
			playerSpritemap.play(curAnimation);
			getcookie();
			var r:Bubble = collide("bubble", x, y) as Bubble;
			if (r)
			{
				new Sfx(Assets.PUNCH).play();
				r.destroy();
				flyhealth--;
			}
			if (flyhealth <= 0)
			{
				//play sucking sound
				destroy();
				new Sfx(Assets.MOMSIGH).play();
				FP.world.add(new BossCaptured(x, y));
			}
			woodenspoontimer--;
		}
		
		public function setupSpritesheet():void 
		{
			playerSpritemap.add("walk_down", [0, 1, 2, 3, 4, 5, 6, 7], 11, true);
			playerSpritemap.add("walk_up", [8,9,10,11,12,13,14,15], 11, true);
			playerSpritemap.add("walk_right", [16,17,18,19,20,21], 11, true);
			playerSpritemap.add("walk_left", [24,25,26,27,28,29], 11, true);
			playerSpritemap.add("stand_down", [0], 0,false);
			playerSpritemap.add("stand_up", [8], 0, false);
			playerSpritemap.add("stand_right", [16], 0, false);
			playerSpritemap.add("stand_left", [24], 0, false);
		}
		public function destroy():void
		{
			FP.world.remove(this);
		}
		
		public function getcookie():void
		{
			if (!target) getNewTarget();
			if (target) turnTowardsTarget();
			x += .001;
			y -= .001;
			if (x > Livingroom.hero.x-10)
			{
				if (collide("wall", x - speed, y))
				{
					x -= .1;
				}
				else
				{
					curAnimation = "walk_right";
					x -= Math.random() * speed * 2;
				}
			}
			if (x < Livingroom.hero.x+10)
			{
				if (collide("wall", x + speed, y))
				{
					x += 0;
				}
				else
				{
					curAnimation = "walk_left";
					x += Math.random() * speed * 2;
				}
			}
			if (y > Livingroom.hero.y-10)
			{
				if (collide("wall", x, y-speed))
				{
					y -= 0;
				}
				else
				{
					y -= Math.random() * speed * 2;
					curAnimation = "walk_up";
				}
			}
			if (y < Livingroom.hero.y+10)
			{
				if (collide("wall", x, y+speed))
				{
					y += 0;
				}
				else
				{
					y += Math.random() * speed * 2;
					curAnimation = "walk_down";
				}
			}
			
			//check wheter no movement occured, in which case the idle animation for the last movement animation is played
			if ((x == Livingroom.hero.x+FP.clamp(2,1,5)) && (y == Livingroom.hero.y+FP.clamp(2,1,5)))
			{
				switch(curAnimation)
				{
					case "walk_left": curAnimation = "stand_left"; break;
					case "walk_right": curAnimation = "stand_right"; break;
					case "walk_up": curAnimation = "stand_up"; break;
					case "walk_down": curAnimation = "stand_down"; break;
				}
			}
			/*vx = SPEEDFORCOOKIE * Math.sin(angle * RAD) * FP.elapsed;
			vy = SPEEDFORCOOKIE * Math.cos(angle * RAD) * FP.elapsed;
			x += vx;
			y += vy;
			*/
		}
		public function turnTowardsTarget():void
		{
			targetDir_x = (target.x - x);
			targetDir_y = (target.y - y);
			if (vy * targetDir_x - vx * targetDir_y > 0)
				angle += turnspeed * FP.elapsed;
			else
				angle -= turnspeed * FP.elapsed;
		}
		public function getNewTarget():void
		{
			target = world.nearestToEntity("player", this);
		}
		
	}

}