package enemies 
{
	import coolthings.Tnt;
	import flash.geom.Point;
	import flash.system.TouchscreenType;
	import net.flashpunk.Entity;
	import net.flashpunk.*;
	import net.flashpunk.utils.*;
	import net.flashpunk.graphics.*;
	import player.Player;
	import worlds.rooms.Bedroom;
	import worlds.rooms.Livingroom;
	import player.Bubble;
	/**
	 * ...
	 * @author Commanderstitch
	 */
	public class Mom extends Entity 
	{		
		//define the dimensions of a single frame.
		public const SPRITE_WIDTH:Number = 46*2;
		public const SPRITE_HEIGHT:Number = 56*2;
		
		//create the spritemap
		
		public var playerSpritemap:Spritemap = new Spritemap(Assets.MOMBOSS, SPRITE_WIDTH, SPRITE_HEIGHT);
		
		//helper variables
		public var curAnimation:String = "stand_down";
		public static var speed:Number = 1;
		public var flyhealth:Number = 500;
		public var woodenspoontimer:Number = 50;
		
		private const turnspeed:Number = 4;
		private const SPEEDFORCOOKIE:Number = 4;
		private const RAD:Number = Math.PI / 180;
		private var vx:Number;
		private var vy:Number;
		private var angle:Number;
		private var targetDir_x:Number;
		private var targetDir_y:Number;
		private var target:Entity;
		private var image:Image;
		
		public function Mom(x:int,y:int) 
		{
			super(x, y);
			setupSpritesheet();
			graphic = playerSpritemap;
			playerSpritemap.play(curAnimation);
			setHitbox(200, 200,0,+100);
			type = "mom";
			layer - 3;
			new Sfx(Assets.GETOUT).play();
			FP.world.add(new Tnt(x, y));
			FP.world.add(new Tnt(x , y + 37));
			FP.world.add(new Tnt(x , y - 37));
			FP.world.add(new Tnt(x+ 53 , y - 37*2));
			FP.world.add(new Tnt(x + 53, y - 37*3));
		}
		public function begin():void
		{

		}
		override public function update():void
		{
			var horizontalMovement:Boolean = true;
			var verticalMovement:Boolean = true;
			if (woodenspoontimer <= 0)
			{
				for (var i:int = 0; i < 30; i++) //ouch!
					FP.world.add(new WoodenSpoon(x, y));
				woodenspoontimer = 30;
			}
			playerSpritemap.play(curAnimation);
			getcookie();
			var r:Bubble = collide("bubble", x, y) as Bubble;
			if (r)
			{
				new Sfx(Assets.MOMHURT).play();
				r.destroy();
				flyhealth--;
			}
			if (flyhealth <= 0)
			{
				//play sucking sound
				destroy();
				new Sfx(Assets.MOMDEAD).play();
				FP.world.add(new BossCaptured(x, y));
				FP.world.add(new BossCaptured(x + 10, y));
				FP.world.add(new BossCaptured(x - 10, y));
				FP.world.add(new BossCaptured(x, y + 10));
				FP.world.add(new BossCaptured(x, y - 10));
				FP.world.add(new BossCaptured(x, y - 30));
				FP.world.add(new BossCaptured(x, y + 30));
				FP.world.add(new BossCaptured(x+20, y));
				destroytnt();
				destroytnt();
				destroytnt();
				destroytnt();
				destroytnt();
			}
			woodenspoontimer--;
		}
		
		public function setupSpritesheet():void 
		{
			playerSpritemap.add("walk_down", [0], 9, false);
			playerSpritemap.add("walk_up", [1], 9, false);
			playerSpritemap.add("walk_right", [0], 9, false);
			playerSpritemap.add("walk_left", [1], 9, false);
			playerSpritemap.add("stand_down", [0], 0, false);
			playerSpritemap.add("stand_up", [1], 0, false);
			playerSpritemap.add("stand_right", [0], 0, false);
			playerSpritemap.add("stand_left", [1], 0, false);
		}
		public function destroy():void
		{
			FP.world.remove(this);
		}
		
		public function getcookie():void
		{
			if (!target) getNewTarget();
			if (target) turnTowardsTarget();
			x += .001;
			y -= .001;
			/*vx = SPEEDFORCOOKIE * Math.sin(angle * RAD) * FP.elapsed;
			vy = SPEEDFORCOOKIE * Math.cos(angle * RAD) * FP.elapsed;
			x += vx;
			y += vy;
			*/
			curAnimation = "walk_right";
		}
		public function turnTowardsTarget():void
		{
			targetDir_x = (target.x - x);
			targetDir_y = (target.y - y);
			if (vy * targetDir_x - vx * targetDir_y > 0)
				angle += turnspeed * FP.elapsed;
			else
				angle -= turnspeed * FP.elapsed;
		}
		public function getNewTarget():void
		{
			target = world.nearestToEntity("player", this);
		}
		public function destroytnt():void
		{
			var enemyListMH:Array = [];
			FP.world.getType("tnt", enemyListMH);
			var mh:Tnt = enemyListMH.pop();
			if (mh != null) mh.destroy();
		}
		
	}

}