package lightingengine 
{
	import flash.display.BitmapData;
	import flash.display.BlendMode;
	import flash.geom.ColorTransform;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.FP;
	/**
	 * ...
	 * @author Noel Berry, thanks noel!
	 */
	public class Lighting extends Entity
	{
		public var canvas:BitmapData;
		public var lights:Vector.<Light> = new Vector.<Light>();
		public var size:Rectangle;
		public var light:Image = new Image(Assets.LIGHT);
		
		private var colorTransform:ColorTransform = new ColorTransform(1, 1, 1, 1);
		private var point:Point = new Point();
		
		public function Lighting() 
		{
			//high above all
			layer = -100;
			
			//canvas
			canvas = new BitmapData(FP.width, FP.height, false, 0xFFFFFF);
			size = new Rectangle(0, 0, FP.width, FP.height);
			
			//set the light render position to center
			light.centerOO();
		}
		public function add(I:Light):void
		{
			lights.push(I);
		}
		public function remove(I:Light):void
		{
			//which do we remove
			for (var i:int = 0; i < lights.length; i++)
			{
				//this one?
				if (I == lights[i])
				{
					lights[i].removed = true;
					//take it out of the vector
					lights.splice(i, 1);
				}
			}
		}
		override public function render():void
		{
			super.render();
			canvas.fillRect(size, 0xFFFFFF);
			for (var i:int; i < lights.length; i++)
			{
				//if removed.. skip
				if (lights[i].removed) { continue; }
				light.scale = lights[i].scale;
				light.alpha = lights[i].alpha;
				
				//render to canvas
				point.x = lights[i].x;
				point.y = lights[i].y;
				light.render(canvas, point, FP.camera);
			}
			FP.buffer.draw(canvas, null, colorTransform, BlendMode.SUBTRACT, null, false);
		}
		
	}

}