package player 
{
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Image;
	import worlds.rooms.Bedroom;
	import net.flashpunk.FP;
	import net.flashpunk.Sfx;
	/**
	 * ...
	 * @author commanderstitch
	 */
	public class Bubble extends Entity
	{
		public static var Bubblespeed:uint = 2;
		public var fangle:Number = 0;
		public var radianAngle:Number = 0;
		
		public function Bubble(x:Number, y:Number) 
		{
			super(x, y);
			graphic = new Image(Assets.BUBBLE, new Rectangle(0, 0, 20, 20));
			setHitboxTo(graphic);
			type = "bubble";
			layer = -2;
			fangle = FP.angle(x, y, FP.world.mouseX, FP.world.mouseY);
			radianAngle = fangle * Math.PI / 180;
		}
		override public function update():void
		{
			super.update();
			if ((fangle > 315) && (fangle <=360)) //right lower
			{
				x += Bubblespeed * Math.cos(radianAngle);
				y -= Bubblespeed * Math.sin(radianAngle);	
			}
			if ((fangle >= 0) && (fangle <= 45)) //right upper
			{
				x += Bubblespeed * Math.cos(radianAngle);
				y -= Bubblespeed * Math.sin(radianAngle);
			}
			if ((fangle > 45) && (fangle <= 135)) //up
			{
				x += Bubblespeed * Math.cos(radianAngle);
				y -= Bubblespeed * Math.sin(radianAngle);
			}
			if ((fangle > 135) && (fangle <= 225)) //left
			{
				x += Bubblespeed * Math.cos(radianAngle);
				y -= Bubblespeed * Math.sin(radianAngle);
			}
			if ((fangle > 225) && (fangle <= 315)) //down
			{
				x += Bubblespeed * Math.cos(radianAngle);
				y -= Bubblespeed * Math.sin(radianAngle);
			}
			if (collide("wall", x, y))
				destroy();
			if (collide("bed", x, y))
				destroy();
		}
		public function destroy():void
		{
			new Sfx(Assets.BUBBLE_POP).play();
			FP.world.add(new BubbleBoom(x, y));
			FP.world.remove(this);
		}
		
	}

}