package player 
{
	import coolthings.Bomb;
	import coolthings.Cookie;
	import flash.geom.Point;
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Spritemap;
	import net.flashpunk.*;
	import net.flashpunk.utils.*;
	import net.flashpunk.graphics.*;
	import ui.Button;
	import ui.skittles.SkittleBlue;
	import ui.skittles.SkittleRed;
	import ui.skittles.SkittleGreen;
	import ui.skittles.SkittleOrange;
	import ui.skittles.SkittlesPink;
	import ui.skittles.SkittleLightBlue;
	import ui.skittles.SkittlePurple;
	import ui.TextMessage;
	import net.flashpunk.Sfx;
	import worlds.Ending;
	import worlds.Menu;
	import worlds.rooms.Bedroom;
	import worlds.rooms.Livingroom;
	
	/**
	 * ...
	 * @author commanderstitch
	 */
	public class Player extends Entity 
	{
		public const SPRITE_WIDTH:Number = 46;
		public const SPRITE_HEIGHT:Number = 56;
		
		public var playerSpritemap:Spritemap = new Spritemap(Assets.PLAYER, SPRITE_WIDTH, SPRITE_HEIGHT);
		
		public var curAnimation:String = "stand_down";
		public static var playermaxhealth:Number = 500;
		public static var speed:Number = 2; //testing... it was at 2
		public static var bubbletimer:int = 10;//testing... it was at 10
		public static var shootimer:int = 10;
		public static var playerhealth:Number = 10;//testing ... it was at 10
		public static var mastercookietrigger:Boolean = true;
		public static var smallcookietrigger:Boolean = true;
		public static var carryingcookie:Boolean = false;
		public static var onlyone:Boolean = false;
		
		//screensaved as points for shooting
		private const UPPERLEFT:Point = new Point(0, 0);
		private const UPPERRIGHT:Point = new Point(1472, 0);
		private const BOTTOMLEFT:Point = new Point(0, 960);
		private const BOTTOMRIGHT:Point = new Point(1472, 960);
		private var currentposition:Point = new Point(0, 0);
		private var currentmouse:Point = new Point(0, 0);
		private var v:Number = 0;
		private var u:Number = 0;
		private var w:Number = 0;
		private var v0:Vector.<Point> = new Vector.<Point>(0, 0);
		private var v1:Vector.<Point> = new Vector.<Point>(0, 0);
		private var v2:Vector.<Point> = new Vector.<Point>(0, 0);
		private var v3:Point = new Point(0, 0);
		private var v4:Point = new Point(0, 0);
		private var v5:Point = new Point(0, 0);
		private var d00:Number = 0;
		private var d01:Number = 0;
		private var d11:Number = 0;
		private var d20:Number = 0;
		private var d21:Number = 0;
		private var denom:Number = 0;
		
		public function Player(x:int,y:int) 
		{
			super(x, y);
			setupSpritesheet();
			graphic = playerSpritemap;
			playerSpritemap.play(curAnimation);
			Input.define("walk_up", Key.W, Key.UP);
			Input.define("walk_down", Key.S, Key.DOWN);
			Input.define("walk_left", Key.A, Key.LEFT);
			Input.define("walk_right", Key.D, Key.RIGHT);
			setHitbox(18, 24, -11, -14);
			type = "player";
			layer = 0;
		}
		override public function update():void
		{
			var horizontalMovement:Boolean = true;
			var verticalMovement:Boolean = true;
			currentposition = new Point(x, y);
			currentmouse = new Point(FP.world.mouseX, FP.world.mouseY);
			playerSpritemap.play(curAnimation);
			if ((Input.mousePressed)&& (carryingcookie == true)) 
			{
				if (onlyone)
				FP.world.add(new Cookie(x, y + 40));
				carryingcookie = false;
				onlyone = false;
				smallcookietrigger = true;
				trace("you dropped the cookie");
			}
			if (Input.check("walk_left"))
			{
				if (collide("wall", x - speed, y))
					x -= 0;
				else
				{
					x -= speed;
					if (Input.mouseDown)
					{
						if (!carryingcookie)
							checkshootingquadrant();
					}
					else
					{
						if (carryingcookie)
							curAnimation = "carry_left";
						else
							curAnimation = "walk_left";
					}
				}
			}
			else if (Input.check("walk_right"))
			{
				if (collide("wall", x + speed, y))
					x += 0;
				else
				{
					x += speed;
					if (Input.mouseDown)
					{
						if (!carryingcookie)
							checkshootingquadrant();
					}
					else
					{
						if (carryingcookie)
							curAnimation = "carry_right";
						else
							curAnimation = "walk_right";
					}
				}
			}
			else
			horizontalMovement = false;
			
			if (Input.check("walk_up"))
			{
				if (collide("wall", x, y - speed))
					y -= 0;
				else
				{
					y -= speed;
					if (Input.mouseDown)
					{
						if (!carryingcookie)
						checkshootingquadrant();
					}
					else
					{
						if (carryingcookie)
							curAnimation = "carry_up";
						else
						curAnimation = "walk_up";
					}
				}
			}
			else if (Input.check("walk_down"))
			{
				if (collide("wall", x, y+speed))
					y += 0;
				else
				{
					y += speed;
					if (Input.mouseDown)
					{
						if (!carryingcookie)
						checkshootingquadrant();
					}
					else
					{
						if (carryingcookie)
							curAnimation = "carry_down";
						else
						curAnimation = "walk_down";
					}
				}
			}
			else 
			verticalMovement = false;
			if ((!verticalMovement) && (!horizontalMovement))
			{
				if (Input.mouseDown)
				{
					if (!carryingcookie)
						checkshootingquadrant();
				}
				else switch(curAnimation)
				{
					case "walk_left":curAnimation = "stand_left"; break;
					case "walk_right":curAnimation = "stand_right"; break;
					case "walk_up":curAnimation = "stand_up"; break;
					case "walk_down":curAnimation = "stand_down"; break;
					case "carry_left":curAnimation = "halt_left"; break;
					case "carry_right":curAnimation = "halt_right"; break;
					case "carry_up":curAnimation = "halt_up"; break;
					case "carry_down":curAnimation = "halt_down"; break;
				}
			}
			if (collide("fly", x, y))
			{
				new Sfx(Assets.OW).play();
				playerhealth--;
			}
			if (playerhealth < 0)
			{
				killplayer();
			}
			if ((collide("cookiejar", x, y)) && (mastercookietrigger == true))
			{
				mastercookietrigger = false;
				new Sfx(Assets.YAYCOOKIE).play();
				carryingcookie = true;
				onlyone = true;
				Globals.cookies--;
			}
			var r:Cookie = collide("cookie", x, y) as Cookie;
			if ((r) && (smallcookietrigger))
			{
				r.destroy();
				smallcookietrigger = false;
				carryingcookie = true;
				onlyone = true;
			}
			if (collide("mom", x, y))
			{
				new Sfx(Assets.BOOM).play();
				FP.world.add(new Bomb(x, y));
				FP.world.add(new Bomb(x+10, y+10));
				FP.world.add(new Bomb(x+30, y+50));
				FP.world.add(new Bomb(x+50, y+100));
				FP.world.add(new Bomb(x+60, y-10));
				FP.world.add(new Bomb(x+100, y-50));
				killplayer();
			}
			shootimer--;
			checkforend();
		}
		public function loadMenu():void
		{
			playermaxhealth = 500;
			speed = 2;//testing only normally at 2
			bubbletimer = 10; //testing only normally at 10
			shootimer = 10;
			playerhealth = 10;//testing only normmaly at 10
			Globals.cookies = 3;
			Globals.cookiesdelivered = 3;
			mastercookietrigger = true;
			smallcookietrigger = true;
			playerhealth = 10;
			carryingcookie = false;
			onlyone = false;
			FP.world = new Menu;
		}
		public function setupSpritesheet():void
		{
			playerSpritemap.add("walk_down", [0, 1, 2, 3, 4, 5, 6, 7], 11, true);
			playerSpritemap.add("walk_up", [8,9,10,11,12,13,14,15], 11, true);
			playerSpritemap.add("walk_right", [16,17,18,19,20,21], 11, true);
			playerSpritemap.add("walk_left", [24,25,26,27,28,29], 11, true);
			playerSpritemap.add("stand_down", [0], 0,false);
			playerSpritemap.add("stand_up", [8], 0, false);
			playerSpritemap.add("stand_right", [16], 0, false);
			playerSpritemap.add("stand_left", [24], 0, false);
			playerSpritemap.add("shoot_down", [32,33,34,35,36,37,38,39], 11, true);
			playerSpritemap.add("shoot_up", [40,41,42,43,44,45,46,47], 11, true);
			playerSpritemap.add("shoot_right", [48,49,50,51,52,53], 11, true);
			playerSpritemap.add("shoot_left", [56, 57, 58, 59, 60, 61], 11, true);
			playerSpritemap.add("carry_down", [64,65,66,67,68,69,70,71], 11, true);
			playerSpritemap.add("carry_up", [72,73,74,75,76,77,78,79], 11, true);
			playerSpritemap.add("carry_right", [80,81,82,83,84,85], 11, true);
			playerSpritemap.add("carry_left", [88, 89, 90, 91, 92, 93], 11, true);
			playerSpritemap.add("halt_down", [64], 0,false);
			playerSpritemap.add("halt_up", [72], 0, false);
			playerSpritemap.add("halt_right", [80], 0, false);
			playerSpritemap.add("halt_left", [88], 0, false);
		}
		public function destroy():void
		{
			FP.world.remove(this);
		}
		public function checkshootingquadrant():void
		{
			if (isInside(currentmouse, currentposition, UPPERLEFT, UPPERRIGHT))
			{
				if (shootimer < 0)
				{
					new Sfx(Assets.BUBBLE_SHOOT).play();
					world.add(new Bubble(x + 11, y -11));
					shootimer = bubbletimer;
				}
				curAnimation = "shoot_up";
			}
			if (isInside(currentmouse, currentposition, BOTTOMLEFT, BOTTOMRIGHT))
			{
				if (shootimer < 0)
				{
					new Sfx(Assets.BUBBLE_SHOOT).play();
					world.add(new Bubble(x + 11, y + 43));
					shootimer = bubbletimer;
				}
				curAnimation = "shoot_down";
			}
			if (isInside(currentmouse, currentposition, UPPERLEFT, BOTTOMLEFT))
			{
				if (shootimer < 0)
				{
					new Sfx(Assets.BUBBLE_SHOOT).play();
					world.add(new Bubble(x-15, y+15));
					shootimer = bubbletimer;
				}
				curAnimation = "shoot_left";
			}
			if (isInside(currentmouse, currentposition, UPPERRIGHT, BOTTOMRIGHT))
			{
				if (shootimer < 0)
				{
					new Sfx(Assets.BUBBLE_SHOOT).play();
					world.add(new Bubble(x + 44, y + 15));
					shootimer = bubbletimer;
				}
				curAnimation = "shoot_right";
			}
		}
		public function isInside(p:Point, p1:Point, p2:Point, p3:Point):Boolean
		{
			v0.push(new Point((p3.x - p1.x), (p3.y - p1.y)));
			v1.push(new Point((p2.x - p1.x), (p2.y - p1.y)));
			v2.push(new Point((p.x - p1.x), (p.y - p1.y)));
			v3 = v0.pop();
			v4 = v1.pop();
			v5 = v2.pop();
			d00 = ((v3.x * v3.x) + (v3.y * v3.y));
			d01 = ((v3.x * v4.x) + (v3.y * v4.y));
			d11 = ((v4.x * v4.x) + (v4.y * v4.y));
			d20 = ((v5.x * v3.x) + (v5.y * v3.y));
			d21 = ((v5.x * v4.x) + (v5.y * v4.y));
			denom = 1 / (d00 * d11 - d01 * d01);
			u = (d11 * d20 - d01 * d21) * denom;
			v = (d00 * d21 - d01 * d20) * denom;
			return (u >= 0) && (v >= 0) && (u + v < 1);
		}
		public function checkforend():void
		{
			if (Globals.cookiesdelivered <= 0)
			FP.world = new Ending;
		}
		public function killplayer():void
		{
			new Sfx(Assets.NO).play();
				for (var i:int = 0; i < 5; i++) //when i get to the room with these in it...
					FP.world.add(new SkittleRed(x, y));
				for (var bl:int = 0; bl < 5; bl++)
					FP.world.add(new SkittleBlue(x, y));
				for (var gr:int = 0; gr < 5; gr++)
					FP.world.add(new SkittleGreen(x, y));
				for (var or:int = 0; or < 5; or++)
					FP.world.add(new SkittleOrange(x, y));
				for (var pink:int = 0; pink < 5; pink++)
					FP.world.add(new SkittlesPink(x, y));
				for (var lb:int = 0; lb < 5; lb++)
					FP.world.add(new SkittleLightBlue(x, y));
				for (var pp:int = 0; pp < 5; pp++)
					FP.world.add(new SkittlePurple(x, y));
				destroy();
				FP.world.add(new Button(x, y+10, "You died. Try again?", loadMenu));
		}
		
	}

}