package worlds.rooms 
{
	import coolthings.Bed;
	import coolthings.Cookie;
	import coolthings.Desk;
	import coolthings.Plant;
	import enemies.Kitten;
	import flash.geom.Point;
	import net.flashpunk.World;
	import player.Player;
	import ui.NewMouse;
	import lightingengine.Light;
	import lightingengine.Lighting;
	import net.flashpunk.FP;
	import ui.TextMessage;
	import ui.TextMessageForDelay;
	import ui.TextMessageForSpeed;
	import ui.TextMessageForMaxHealth;
	
	/**
	 * ...
	 * @author commanderstitch
	 */
	public class Bedroom extends World 
	{
		public static var hero:Player;
		//public var messageposition:TextMessage;
		public var cameraTarget:Point = new Point();
		public var cameraOffset:Point = new Point();
		public var cameraShake:Number = 0;
		public var cameraEffect:Number = 0;
		public var width:int = 736 * 2;
		public var height:int = 480 * 2;
		public var previoushealth:Number = 0;
		//lighting
		public var lighting:Lighting;
		public var lightMouse:Light;
		
		public function Bedroom() 
		{
			add(new NewMouse(Assets.Hand_ingame, true));
			add(new Bedroomloader);
			add(hero = new Player(574, 12)); //Main game clause
			for (var i:int = 0; i < 9; i++) //when i get to the room with these in it...
				add(new Kitten(FP.clamp(i * Math.random() * 40, width/2 -40, width/2 + 40), FP.clamp(i * Math.random() * 25, height/2 - 50, height/2 +50))); 
			//--more for lighting
			//add(lighting = new Lighting());
			//--add lights to the screen
			//lighting.add(new Light(736, 20, 2, 1));
			//lighting.add(lightMouse = new Light(0, 0, 1.5, 1));
			addobjects();
		}
		override public function begin():void
		{
			//snap the camera to starting point
			cameraTarget.x = FP.clamp(hero.x - 350, 0, width - 736);
			cameraTarget.y = FP.clamp(hero.y - 200, 0, height - 480);
			camera.x = cameraTarget.x;
			camera.y = cameraTarget.y;
			add(new TextMessage(camera.x, camera.y, "Health: " + Player.playerhealth));
		}
		override public function update():void
		{
			super.update();
			//---lighting so it follows the player
			//lightMouse.x = hero.x;
			//lightMouse.y = hero.y;
			//now the camera is following the player
			cameraTarget.x = FP.clamp(hero.x - 350, 0, width - 736);
			cameraTarget.y = FP.clamp(hero.y - 200, 0, height - 480);
			camera.x += (cameraTarget.x - camera.x) * 0.1;
			camera.y += (cameraTarget.y - camera.y) * 0.1;
			//update message position
			add(new TextMessage(camera.x + 550, camera.y + 50, "Health: " + Player.playerhealth));
			destroymessage();
			add(new TextMessageForMaxHealth(camera.x + 550, camera.y + 0, "HealthMax: " + Player.playermaxhealth));
			destroymessageformaxhealth();
			add(new TextMessageForSpeed(camera.x + 550, camera.y + 100, "Speed: " + Player.speed));
			destroymessageforspeed();
			add(new TextMessageForDelay(camera.x + 550, camera.y + 150, "FireDelay: " + Player.bubbletimer));
			destroymessagefordelay();

			previoushealth = Player.playerhealth;
			if (hero.x < 0)
			{
				trace("you've gone too far LEFT. Load next level now!");
			}
			else if (hero.x > 736 * 2)
			{
				trace("you've gone too far RIGHT. Load next level now!");
			}
			else if (hero.y > 480 * 2)
			{
				trace("you've gone too far DOWN. Load next level now!");
			}
			else if (hero.y < 0)
			{
				trace("you've gone too far UP. Load next level now!");
				FP.world = new Livingroom;
			}
			
			if (cameraShake > 0)
			{
				FP.angleXY(cameraOffset, FP.random * 360, FP.random * cameraEffect);
				cameraEffect *= 0.95;
				cameraShake -= FP.elapsed;
				if (cameraShake <= 0)
				cameraOffset.x = cameraOffset.y = 0;
			}
		}
		override public function render():void
		{
			var xx:Number = camera.x;
			var yy:Number = camera.y;
			camera.x = Math.round(camera.x + cameraOffset.x);
			camera.y = Math.round(camera.y + cameraOffset.y);
			super.render();
			camera.x = xx;
			camera.y = yy;
		}
		public function destroymessage():void
		{
			var enemyList:Array = [];
			getType("textmessage", enemyList);
			var a:TextMessage = enemyList.pop();
			if (a != null) a.destroy();
		}
		public function destroymessageforspeed():void
		{
			var enemyLists:Array = [];
			getType("textmessageforspeed", enemyLists);
			var az:TextMessageForSpeed = enemyLists.pop();
			if (az != null) az.destroy();
		}
		public function destroymessagefordelay():void
		{
			var enemyTexts:Array = [];
			getType("textmessagefordelay", enemyTexts);
			var dl:TextMessageForDelay = enemyTexts.pop();
			if (dl !=  null) dl.destroy();
		}
		public function destroymessageformaxhealth():void
		{
			var enemyListMH:Array = [];
			getType("textmessageformaxhealth", enemyListMH);
			var mh:TextMessageForMaxHealth = enemyListMH.pop();
			if (mh != null) mh.destroy();
		}
		public function addobjects():void
		{
			add(new Bed(500, 500));
			add(new Desk(600, 500));
			add(new Plant(800, 400));
		}
	}

}