package worlds.rooms 
{
	import coolthings.Cookie;
	import coolthings.CookieJar;
	import coolthings.Oven;
	import enemies.EvilSister;
	import enemies.GreenKitten;
	import enemies.Kitten;
	import enemies.KittenBlue;
	import flash.geom.Point;
	import mx.modules.ModuleManager;
	import net.flashpunk.World;
	import player.Player;
	import ui.NewMouse;
	import lightingengine.Light;
	import lightingengine.Lighting;
	import net.flashpunk.FP;
	import ui.TextMessage;
	import ui.TextMessageForDelay;
	import ui.TextMessageForSpeed;
	import ui.TextMessageForMaxHealth;
	import enemies.Mom;
	import enemies.Fly;
	import enemies.KittenRed;
	import coolthings.Goatimage;
	
	/**
	 * ...
	 * @author commanderstitch
	 */
	public class Livingroom extends World 
	{
		public static var hero:Player;
		//public var messageposition:TextMessage;
		public var cameraTarget:Point = new Point();
		public var cameraOffset:Point = new Point();
		public var cameraShake:Number = 0;
		public var cameraEffect:Number = 0;
		public var width:int = 736 * 2;
		public var height:int = 480 * 2;
		public var previoushealth:Number = 0;
		//lighting
		public var lighting:Lighting;
		public var lightMouse:Light;
		private var onehit:Boolean = true;
		private var singlehit:Boolean = true;
		private var globalspeedincrease:Boolean = true;
		
		public function Livingroom() 
		{
			add(new NewMouse(Assets.Hand_ingame, true));
			add(new LivingroomLoader);
			add(hero = new Player(652, 926)); //mainspawn
			for (var i:int = 0; i < 5; i++) //when i get to the room with these in it...
				add(new Kitten(FP.clamp(i * Math.random() * 40, 40, width), FP.clamp(i * Math.random() * 25, 50, height))); 
			//--more for lighting
			add(lighting = new Lighting());
			//--add light to the screen
			lighting.add(lightMouse = new Light(0, 0, 4, 1));
			addobjects();
		}
		override public function begin():void
		{
			//snap the camera to starting point
			cameraTarget.x = FP.clamp(hero.x - 350, 0, width - 736);
			cameraTarget.y = FP.clamp(hero.y - 200, 0, height - 480);
			camera.x = cameraTarget.x;
			camera.y = cameraTarget.y;
			add(new TextMessage(camera.x, camera.y, "Health: " + Player.playerhealth));
		}
		override public function update():void
		{
			super.update();
			//---lighting so it follows the player
			lightMouse.x = hero.x;
			lightMouse.y = hero.y;
			//now the camera is following the player
			cameraTarget.x = FP.clamp(hero.x - 350, 0, width - 736);
			cameraTarget.y = FP.clamp(hero.y - 200, 0, height - 480);
			camera.x += (cameraTarget.x - camera.x) * 0.1;
			camera.y += (cameraTarget.y - camera.y) * 0.1;
			
			add(new TextMessage(camera.x + 550, camera.y + 50, "Health: " + Player.playerhealth));
			destroymessage();
			add(new TextMessageForMaxHealth(camera.x + 550, camera.y + 0, "HealthMax: " + Player.playermaxhealth));
			destroymessageformaxhealth();
			add(new TextMessageForSpeed(camera.x + 550, camera.y + 100, "Speed: " + Player.speed));
			destroymessageforspeed();
			add(new TextMessageForDelay(camera.x + 550, camera.y + 150, "FireDelay: " + Player.bubbletimer));
			destroymessagefordelay();

			previoushealth = Player.playerhealth;
			if (hero.x < 0)
			{
				trace("you've gone too far LEFT. Load next level now!");
			}
			else if (hero.x > 736 * 2)
			{
				trace("you've gone too far RIGHT. Load next level now!");
			}
			else if (hero.y > 480 * 2)
			{
				trace("you've gone too far DOWN. Load next level now!");
				FP.world = new Bedroom();
			}
			else if (hero.y < 0)
			{
				trace("you've gone too far UP. Load next level now!");
			}
			
			if (cameraShake > 0)
			{
				FP.angleXY(cameraOffset, FP.random * 360, FP.random * cameraEffect);
				cameraEffect *= 0.95;
				cameraShake -= FP.elapsed;
				if (cameraShake <= 0)
				cameraOffset.x = cameraOffset.y = 0;
			}
			globalevents();
		}
		override public function render():void
		{
			var xx:Number = camera.x;
			var yy:Number = camera.y;
			camera.x = Math.round(camera.x + cameraOffset.x);
			camera.y = Math.round(camera.y + cameraOffset.y);
			super.render();
			camera.x = xx;
			camera.y = yy;
		}
		public function destroymessage():void
		{
			var enemyList:Array = [];
			getType("textmessage", enemyList);
			var a:TextMessage = enemyList.pop();
			if (a != null) a.destroy();
		}
				public function destroymessageforspeed():void
		{
			var enemyLists:Array = [];
			getType("textmessageforspeed", enemyLists);
			var az:TextMessageForSpeed = enemyLists.pop();
			if (az != null) az.destroy();
		}
		public function destroymessagefordelay():void
		{
			var enemyTexts:Array = [];
			getType("textmessagefordelay", enemyTexts);
			var dl:TextMessageForDelay = enemyTexts.pop();
			if (dl !=  null) dl.destroy();
		}
		public function destroymessageformaxhealth():void
		{
			var enemyListMH:Array = [];
			getType("textmessageformaxhealth", enemyListMH);
			var mh:TextMessageForMaxHealth = enemyListMH.pop();
			if (mh != null) mh.destroy();
		}
		public function addobjects():void
		{
			add(new CookieJar(800, 700));
			add(new EvilSister(100, 700));
			add(new Oven(737, 436));
			add(new Goatimage(681, 407));
		}
		public function globalevents():void
		{
			if ((Globals.cookies == 0) && (onehit)) //for testing normally it's at 0
			{
				onehit = false;
				add(new Mom(1300, 600));
				add(new GreenKitten(600, 300));
				add(new KittenBlue(800, 400));
				for (var i:int = 0; i < 50; i++)
				add(new Kitten(FP.clamp(i * Math.random() * 40, 40, width), FP.clamp(i * Math.random() * 25, 50, height)));
			}
			if ((Globals.cookies == 1) && (singlehit)) //for testing... norm = 1
			{
				singlehit = false;
				onehit = true;
				add(new GreenKitten(600, 300));
				add(new KittenBlue(800, 400));
				for (var ii:int = 0; ii < 25; ii++)
				add(new Kitten(FP.clamp(ii * Math.random() * 40, 40, width), FP.clamp(ii * Math.random() * 25, 50, height)));
			}
				
			if ((Globals.cookies == 2) && (globalspeedincrease))
			{
				singlehit = true;
				add(new GreenKitten(600, 300));
				globalspeedincrease = false;
				Kitten.speed = 2;
				KittenRed.speed = 3;
				Fly.speed = 2;
				Mom.speed = 2;
				for (var iii:int = 0; iii < 10; iii++)
				add(new Kitten(FP.clamp(iii * Math.random() * 40, 40, width), FP.clamp(iii * Math.random() * 25, 50, height)));
			}
			if (Globals.cookies == 3)
				globalspeedincrease = true;
				Kitten.speed = 1;
				KittenRed.speed = 2;
				Fly.speed = 1;
				Mom.speed = 1;
		}
	}

}